<template lang="pug">
b-card( title="Группы пользователей" )
	template( #icon )
		router-link.button.is-small.is-primary.has-text-weight-bold( :to='{ name: "AddGroup" }' ) Добавить
	b-table( :data='groups' :columns='columns' :loading='pending' )
		template( #clients='{ item }' ) {{ item.clients.length }}
		template( #buttons='{ item }' )
			.buttons.are-small.mb-0
				.button.is-danger( @click='remove(item.id)' )
					span.icon.is-small
						i.fa-solid.fa-trash-can
				router-link.button.is-link( :to='{ name: "Group", params: { id: item.id } }' )
					span.icon.is-small
						i.fa-solid.fa-arrow-right
		template( #empty ) Пока не создано ни одной группы

b-pagination( v-model='page' :total='last_page' )
</template>

<script setup>
import BTable from "@/components/table/Table.vue"
import BPagination from "@/components/table/Pagination.vue"

import { useGroupStore } from "@/stores/group.js"
import { computed, onMounted, ref, watch } from "vue-demi"

const columns = [
	{
		label: "ID",
		field: "id"
	},
	{
		label: "Название",
		field: "name"
	},
	{
		label: "Кол-во пользователей",
		field: "clients"
	},
	{
		field: "buttons"
	}
]

const gs = useGroupStore()

const pending = ref(false)

const groups = computed(() => gs.groups)
const last_page = computed(() => gs.last_page)
const page = computed({
	get: () => gs.page,
	set: val => gs.page = val
})

const fetch = async () => {
	gs.limit = 20

	pending.value = true
	await gs.getGroups()
	pending.value = false
}

const remove = async id => {
	pending.value = true
	await gs.removeGroup(id)
	fetch()
}

watch(page, fetch)

onMounted(() => {
	gs.page = 1
	fetch()
})
</script>